/***************************************************************************
                          kwhois.cpp  -  description
                             -------------------
    begin                : Mon Aug 6 2001
    copyright            : (C) 2001 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kwhois.h"

KWhois::KWhois(QWidget *parent, const char *name ) : KWhoisUI(parent,name) {
	homeDir=getHomeDirectory(getuid());
	mentryResult->setReadOnly(true);
	// Layout1->setResizeMode(QLayout::FreeResize);
	initMenuBar();
	initComboBox();
//	initWhoisDict();
	
	whoisProcess=new KProcess();
	connect(whoisProcess,SIGNAL(receivedStdout(KProcess *,char *,int)),this,SLOT(receiveOutput(KProcess *,char *,int)));
	connect(whoisProcess,SIGNAL(receivedStderr(KProcess *,char *,int)),this,SLOT(receiveOutput(KProcess *,char *,int)));
	
	
}
KWhois::~KWhois(){
	delete simpleConfig;	
	delete whoisProcess;
	delete simpleConfig;
}
/** No descriptions */
void KWhois::initComboBox(){
	QStringList *groupList;
	KEntry test;
	QString test1;
	KRegExp *reg;
	
	comboWhois->clear();
	whoisDict.clear();
	simpleConfig=new KSimpleConfig("kwhoisrc",false);
	simpleConfig->setGroup("");
	comboWhois->setCurrentItem(simpleConfig->readNumEntry("default",0));
	setWhoisBinary(simpleConfig->readEntry("whoisBinPath","/usr/bin/whois"));
	setWhoisType(simpleConfig->readNumEntry("whoisType",0));
	setWhoiseMailAddress(simpleConfig->readEntry("eMail","root@localhost"));
	setWhoisConfigVersion(simpleConfig->readDoubleNumEntry("Version",0.5));
	groupList=new QStringList();
	*groupList=simpleConfig->groupList();
	reg=new KRegExp("^Registrar (.+?)","");
	for ( QStringList::Iterator it = groupList->begin(); it != groupList->end(); ++it ) {
		if (!(*it).contains("KFile")) {
			if (whoisConfigVersion>=1) {
				if ((*it).contains("Registrar")) {
					if (reg->match((*it))) {
						simpleConfig->setGroup(*it);		
						comboWhois->insertItem(QString(reg->group(1)));
						whoisDict.insert(QString(reg->group(1)),new QString(simpleConfig->readEntry("Host","")));
					}
				}
			} else {
				simpleConfig->setGroup(*it);		
				comboWhois->insertItem((*it));
				whoisDict.insert((*it),new QString(simpleConfig->readEntry("Host","")));
			}		
		}
	}
}


/** No descriptions */
void KWhois::slotSearchReturn(){
	QRegExp *reg;
	reg=new QRegExp("^-",false);
	
	mentryResult->clear();
	outputDisplay="";
	whoisProcess->clearArguments();
	if (whoisDict[comboWhois->currentText()] && !entrySearch->text().isEmpty()) {
		if (reg->match(entrySearch->text())==-1) {
			*whoisProcess << getWhoisBinary();
			if (getWhoisType()==0||getWhoisType()==2) {
				*whoisProcess << "-h";
				*whoisProcess << *(whoisDict[comboWhois->currentText()]);
		// *whoisProcess << "";
				*whoisProcess << entrySearch->text();
			}
			if (getWhoisType()==1) {
				*whoisProcess << entrySearch->text()+"@"+*(whoisDict[comboWhois->currentText()]);
			}
			whoisProcess->start(KProcess::NotifyOnExit,KProcess::AllOutput);
		}
	}
}
/** No descriptions */
void KWhois::receiveOutput(KProcess *proc,char *buffer,int len){
	char *buf1;
	
	buf1=(char *)malloc(len+1);
	buf1=(char *)memmove(buf1,buffer,len);
	buf1[len]=0;
	outputDisplay.append(buf1);
	mentryResult->setText(outputDisplay);
	free(buf1);
}
/** No descriptions */
void KWhois::slotServerActivated(int item){

	if (!whoisDict[comboWhois->currentText()]) {	
		entrySearch->setText("Whois Server not implemented !");
		entrySearch->setReadOnly(true);
	} else {
		entrySearch->setText("");
		mentryResult->setText("");
		entrySearch->setReadOnly(false);
	}
}
/** No descriptions */
char * KWhois::getUserName(int UID){
	struct passwd *pass;
	pass=getpwuid(UID);
	return(pass->pw_name);
}
/** No descriptions */
char * KWhois::getHomeDirectory(int UID){
	struct passwd *pass;
	pass=getpwuid(UID);
	return(pass->pw_dir);
}

/** No descriptions */
void KWhois::closeEvent ( QCloseEvent * e){

	writeConfig();
	simpleConfig->sync();
	QWidget::closeEvent(e);
}

/** No descriptions */
void KWhois::slotConfig(){
	KWhoisConfig *config;
	

	config=new KWhoisConfig(this,"",whoisDict);
	if (config->exec()) {
		clearConfig();
		whoisDict=config->getServerDict();
		writeConfig();
		delete simpleConfig;
		initComboBox();
	
	}	
	delete config;
}
/** No descriptions */
void KWhois::setConfig(KSimpleConfig *config){
	simpleConfig=config;
}
/** No descriptions */
void KWhois::clearConfig(){
	QStringList *groupList;
	
	groupList=new QStringList();
	*groupList=simpleConfig->groupList();
	
	for ( QStringList::Iterator it = groupList->begin(); it != groupList->end(); ++it ) {
			simpleConfig->deleteGroup(*it);		
	}	
}
/** No descriptions */
void KWhois::slotBtnClose(){
	close();
}
/** No descriptions */
void KWhois::resizeEvent(QResizeEvent *sizeEvent){
	QWidget::resizeEvent(sizeEvent);
	mentryResult->resize(width()-mentryResult->x()-10,height()-mentryResult->y()-10);
}
/** No descriptions */
void KWhois::initMenuBar(){
	QPopupMenu *configuration;
	QPopupMenu *file;
	QPopupMenu *ripe,*ripe1,*ripe2;
	QPopupMenu *internic;
	KHelpMenu *help;
	
	menuBar=new KMenuBar(this);
	file=new QPopupMenu();
	file->insertItem(i18n("&Save Result"),100,1);
	file->insertSeparator(2);
	file->insertItem(i18n("&Quit"),110,3);
	connect(file,SIGNAL(activated(int)),this,SLOT(slotFileClicked(int)));	
	configuration=new QPopupMenu();
	configuration->insertItem(i18n("&Settings"),100,1);
	configuration->insertItem(i18n("&Whois Server"),101,2);      	
	connect(configuration,SIGNAL(activated(int)),this,SLOT(slotMenuClicked(int)));
	ripe=new QPopupMenu();
	ripe1=new QPopupMenu();
   ripe1->insertItem(i18n("AS-BLOCK"),100,1);
	ripe1->insertItem(i18n("AS-SET"),101,2);
	ripe1->insertItem(i18n("AUT-NUM"),102,3);
	ripe1->insertItem(i18n("DOMAIN"),103,4);
	ripe1->insertItem(i18n("FILTER-SET"),104,5);
	ripe1->insertItem(i18n("INET6NUM"),105,6);
	ripe1->insertItem(i18n("INETNUM"),106,7);
	ripe1->insertItem(i18n("INET-RTR"),107,8);
	ripe1->insertItem(i18n("KEY-CERT"),108,9);
	ripe1->insertItem(i18n("LIMERICK"),109,10);
	ripe1->insertItem(i18n("MNTNER"),110,11);
	ripe1->insertItem(i18n("PEERING-SET"),111,12);
	ripe1->insertItem(i18n("PERSON"),112,13);
	ripe1->insertItem(i18n("ROLE"),113,14);
	ripe1->insertItem(i18n("ROUTE"),114,15);
	ripe1->insertItem(i18n("ROUTE-SET"),115,16);
	ripe1->insertItem(i18n("RTR-SET"),116,17);

	ripe2=new QPopupMenu();
   ripe2->insertItem(i18n("AS-BLOCK"),200,1);
	ripe2->insertItem(i18n("AS-SET"),201,2);
	ripe2->insertItem(i18n("AUT-NUM"),202,3);
	ripe2->insertItem(i18n("DOMAIN"),203,4);
	ripe2->insertItem(i18n("FILTER-SET"),204,5);
	ripe2->insertItem(i18n("INET6NUM"),205,6);
	ripe2->insertItem(i18n("INETNUM"),206,7);
	ripe2->insertItem(i18n("INET-RTR"),207,8);
	ripe2->insertItem(i18n("KEY-CERT"),208,9);
	ripe2->insertItem(i18n("LIMERICK"),209,10);
	ripe2->insertItem(i18n("MNTNER"),210,11);
	ripe2->insertItem(i18n("PEERING-SET"),211,12);
	ripe2->insertItem(i18n("PERSON"),212,13);
	ripe2->insertItem(i18n("ROLE"),213,14);
	ripe2->insertItem(i18n("ROUTE"),214,15);
	ripe2->insertItem(i18n("ROUTE-SET"),215,16);
	ripe2->insertItem(i18n("RTR-SET"),216,17);
	
		
	ripe->insertItem(i18n("&RIPE templates"),ripe1);
	ripe->insertItem(i18n("RIPE &verbose templates"),ripe2);
	ripe->insertSeparator(2);
	ripe->insertItem(i18n("Inversive Query"),300,3);
	connect(ripe1,SIGNAL(activated(int)),this,SLOT(slotRIPEClicked(int)));
	connect(ripe2,SIGNAL(activated(int)),this,SLOT(slotRIPEClicked(int)));
	connect(ripe,SIGNAL(activated(int)),this,SLOT(slotRIPEClicked(int)));
	internic=new QPopupMenu();
	internic->insertItem(i18n("Registrar Search"),500,1);
	internic->insertItem(i18n("Nameserver Search"),501,2);
	connect(internic,SIGNAL(activated(int)),this,SLOT(slotINTERNICClicked(int)));	
	help=new KHelpMenu(this,kapp->aboutData());
	menuBar->insertItem(i18n("&File"),file);
	menuBar->insertItem(i18n("&RIPE Tools"),ripe);
	menuBar->insertItem(i18n("&Internic Tools"),internic);
	menuBar->insertItem(i18n("&Configuration"),configuration);
	menuBar->insertItem(i18n("&Help"),help->menu());
	menuBar->show();
}
/** No descriptions */
void KWhois::slotMenuClicked(int id){
	KWhoisConfig2 *config2;

	switch(id) {
		case 100:
				config2=new KWhoisConfig2(this,"",getWhoisBinary());
				config2->setWhoisName(whoisBinary);
				config2->setWhoisType(whoisType);
				config2->setEmailAddress(eMailAddress);
				if (config2->exec()) {
					setWhoisBinary(QString(config2->getWhoisName()));
					setWhoisType(config2->getWhoisType());
					setWhoiseMailAddress(config2->getEmail());
				}
				delete config2;
			break;
		case 101:
			slotConfig();
			break;
	}
}
/** No descriptions */
void KWhois::setWhoisBinary(const QString &binary){
	whoisBinary=binary;
}
/** No descriptions */
const QString & KWhois::getWhoisBinary(){
	return whoisBinary;
}
/** No descriptions */
void KWhois::slotFileClicked(int id){
	QString str;
	QString bla;
	QFile f;
	switch(id) {
		case 100:

			str=KFileDialog::getSaveFileName("","*.whois|KWhois Result File",this,"Save KWhois Query Result");			
			if (!str.contains(".")) {
				str=str+".whois";
			}
			f.setName(str);
			if ( f.open(IO_ReadWrite) ) {    // file opened successfully
				QTextStream t( &f );        // use a text stream
				bla=mentryResult->text();
				t << bla;
			}
			f.close();
		break;
		case 110:
			close();
		break;
	}
}

/** No descriptions */
void KWhois::setWhoisType(const int whoisT){
	whoisType=whoisT;
}
/** No descriptions */
const int  KWhois::getWhoisType(){
	return whoisType;
}
/** No descriptions */
void KWhois::slotRIPEClicked(int menu_id){
	mentryResult->clear();
	outputDisplay="";
	whoisProcess->clearArguments();

	switch(menu_id) {
	
		case 100: // as-block
			generateWhoisTemplateCommand("as-block",false);
		break;
		case 101: // as-set
			generateWhoisTemplateCommand("as-set",false);
		break;		
		case 102: // aut-num
			generateWhoisTemplateCommand("aut-num",false);
		break;
		case 103: // domain
			generateWhoisTemplateCommand("domain",false);
		break;		
		case 104: // filter-set
			generateWhoisTemplateCommand("filter-set",false);
		break;		
		case 105: // inet6num
			generateWhoisTemplateCommand("inet6num",false);
		break;				
		case 106: // inetnum
			generateWhoisTemplateCommand("inetnum",false);
		break;		
		case 107: // inet-rtr
			generateWhoisTemplateCommand("inet-rtr",false);
		break;		
		case 108: // key-cert
			generateWhoisTemplateCommand("key-cert",false);
		break;		
		case 109: // limerick
			generateWhoisTemplateCommand("limerick",false);
		break;		
		case 110: // mntner
			generateWhoisTemplateCommand("mntner",false);
		break;		
		case 111: // peering-set
			generateWhoisTemplateCommand("peering-set",false);
		break;		
		case 112: // person
			generateWhoisTemplateCommand("person",false);
		break;		
		case 113: // role
			generateWhoisTemplateCommand("role",false);
		break;				
		case 114: // route
			generateWhoisTemplateCommand("route",false);
		break;				
		case 115: // route-set
			generateWhoisTemplateCommand("route-set",false);
		break;		
		case 116: // rtr-set
			generateWhoisTemplateCommand("rtr-set",false);
		break;
		
		case 200: // as-block
			generateWhoisTemplateCommand("as-block",true);
		break;
		case 201: // as-set
			generateWhoisTemplateCommand("as-set",true);
		break;		
		case 202: // aut-num
			generateWhoisTemplateCommand("aut-num",true);
		break;
		case 203: // domain
			generateWhoisTemplateCommand("domain",true);
		break;		
		case 204: // filter-set
			generateWhoisTemplateCommand("filter-set",true);
		break;		
		case 205: // inet6num
			generateWhoisTemplateCommand("inet6num",true);
		break;				
		case 206: // inetnum
			generateWhoisTemplateCommand("inetnum",true);
		break;		
		case 207: // inet-rtr
			generateWhoisTemplateCommand("inet-rtr",true);
		break;		
		case 208: // key-cert
			generateWhoisTemplateCommand("key-cert",true);
		break;		
		case 209: // limerick
			generateWhoisTemplateCommand("limerick",true);
		break;		
		case 210: // mntner
			generateWhoisTemplateCommand("mntner",true);
		break;		
		case 211: // peering-set
			generateWhoisTemplateCommand("peering-set",true);
		break;		
		case 212: // person
			generateWhoisTemplateCommand("person",true);
		break;		
		case 213: // role
			generateWhoisTemplateCommand("role",true);
		break;				
		case 214: // route
			generateWhoisTemplateCommand("route",true);
		break;				
		case 215: // route-set
			generateWhoisTemplateCommand("route-set",true);
		break;		
		case 216: // rtr-set
			generateWhoisTemplateCommand("rtr-set",true);
		break;
		
		
		case 300:
			ShowInverseDlg();
		break;		
	}
	whoisProcess->start(KProcess::NotifyOnExit,KProcess::AllOutput);	
}
/** No descriptions */
void KWhois::generateWhoisTemplateCommand(const QString &templateStr,bool verbose){
	*whoisProcess << getWhoisBinary();
	if (getWhoisType()==0||getWhoisType()==2) {
		*whoisProcess << "-h";
		*whoisProcess << "whois.ripe.net";
		*whoisProcess << "--";
		if (verbose==false) {
			*whoisProcess << "-t "+templateStr;
		} else {
			*whoisProcess << "-v "+templateStr;
		}
	}
	if (getWhoisType()==1) {
		if (verbose==false) {
			*whoisProcess << "\"-t "+templateStr+"\"@whois.ripe.net";
		} else {
			*whoisProcess << "\"-v "+templateStr+"\"@whois.ripe.net";
		}
	}	
}



/** No descriptions */
const QString & KWhois::getWhoiseMail(){
	return eMailAddress;
}
/** No descriptions */
void KWhois::setWhoiseMailAddress(const QString &email){
	eMailAddress=email;
}
/** No descriptions */
void KWhois::ShowInverseDlg(){
	KWhoisRIPEInverse *inverseDlg;
	QString bla;
	QString bla1;
	inverseDlg=new KWhoisRIPEInverse(this,"inverse");
	if (inverseDlg->exec()) {
		bla=inverseDlg->getAttributes();
		bla1=inverseDlg->getQueryString();
		mentryResult->clear();
		outputDisplay="";
		whoisProcess->clearArguments();	
		generateInverseWhoisCommand(bla+" "+bla1);
		whoisProcess->start(KProcess::NotifyOnExit,KProcess::AllOutput);	
	}
	delete inverseDlg;
}
/** No descriptions */
void KWhois::generateInverseWhoisCommand(const QString &templateStr){
	*whoisProcess << getWhoisBinary();
	if (getWhoisType()==0||getWhoisType()==2) {
		*whoisProcess << "-h";
		*whoisProcess << "whois.ripe.net";
		*whoisProcess << "--";
		*whoisProcess << "-i "+templateStr;

	}
	if (getWhoisType()==1) {
		*whoisProcess << "\"-t "+templateStr+"\"@whois.ripe.net";
	}	
}
/** No descriptions */
void KWhois::slotINTERNICClicked(int id){
	switch(id) {
		case 500: // Registrar Search
			ShowInternicRegistrarDlg();
		break;
		
		case 501: // Nameserver Search
			ShowInternicNameserverSearchDlg();
		break;
	}
}

/** No descriptions */
void KWhois::ShowInternicRegistrarDlg(){

	KWhoisInterReg *internicReg;
	internicReg=new KWhoisInterReg(this,"bla",getWhoisBinary(),getWhoisType(),whoisDict);
	
	if (internicReg->exec()) {
		clearConfig();
		whoisDict=internicReg->getDict();
		writeConfig();
		delete simpleConfig;
		initComboBox();
	}
	delete internicReg;
}
/** No descriptions */
void KWhois::writeConfig(){
	QAsciiDictIterator<QString> it(whoisDict);
	clearConfig();
	simpleConfig->setGroup("");
	simpleConfig->writeEntry("whoisBinPath",getWhoisBinary());
	simpleConfig->writeEntry("whoisType",(int)getWhoisType());
	simpleConfig->writeEntry("default",comboWhois->currentItem());
	simpleConfig->writeEntry("eMail",getWhoiseMail());
	simpleConfig->writeEntry("Version",1.0);	
	while (it.current()) {
		if(!it.current()->contains("Registrar ")) {
			simpleConfig->setGroup("Registrar "+QString(it.currentKey()));
		} else {
			simpleConfig->setGroup(QString(it.currentKey()));
		}
		simpleConfig->writeEntry("Host",*it.current());
		simpleConfig->sync();
		++it;
	}
	// delete simpleConfig;
}
/** No descriptions */
void KWhois::ShowInternicNameserverSearchDlg(){
	KWhoisInternicNameserverSearch *nameserverDlg;
	
	nameserverDlg=new  KWhoisInternicNameserverSearch(this,"WhoisInternicSearch",getWhoisBinary(),getWhoisType());
	if (nameserverDlg->exec()) {
		;
	}
	delete nameserverDlg;
}
/** No descriptions */
void KWhois::setWhoisConfigVersion(double version){
	whoisConfigVersion=version;
}
