/***************************************************************************
                          kwhois.h  -  description
                             -------------------
    begin                : Mon Aug 6 2001
    copyright            : (C) 2001 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KWHOIS_H
#define KWHOIS_H

#include <kapp.h>
#include <qwidget.h>
#include <kwhoisui.h>
#include <kwhoisconfig2.h>
#include <qcombobox.h>
#include <qasciidict.h>
#include <kprocess.h>
#include <stdlib.h>
#include <qmultilineedit.h>
#include <qlineedit.h>
#include <unistd.h>
#include <pwd.h>
#include <sys/types.h>
#include <stdio.h>
#include <ksimpleconfig.h>
#include <kconfigdata.h>
#include <kwhoisconfig.h>
#include <kglobal.h>
#include <qregexp.h>
#include <kregexp.h>
#include <kmenubar.h>
#include <qpopupmenu.h>
#include <klocale.h>
#include <khelpmenu.h>
#include <kpopupmenu.h>
#include <kaboutdata.h>
#include <qlayout.h>
#include <qrect.h>
#include <qfile.h>
#include <qtextstream.h>
#include <kfiledialog.h>
#include <kwhoisripeinverse.h>
#include <kwhoisinterreg.h>
#include <kwhoisinternicnameserversearch.h>




/**
  *@author Stephan Hermann
  */

class KWhois : public KWhoisUI  {
   Q_OBJECT
public: 
	KWhois(QWidget *parent=0, const char *name=0);
	~KWhois();
  /** No descriptions */
  void setConfig(KSimpleConfig *config);
  /** No descriptions */
  void setWhoisBinary(const QString &binary);
protected:
	/** No descriptions */
	void generateWhoisTemplateCommand(const QString &templateStr,bool verbose);
private: // Private methods
  /** No descriptions */
  void initComboBox();
private: // Private attributes
  /**  */
  QAsciiDict<QString> whoisDict;
  /**  */
  KProcess* whoisProcess;
  /**  */
  QString outputDisplay;
  /**  */
  QString homeDir;
  /**  */
  KSimpleConfig *simpleConfig;
  /**  */
  KMenuBar *menuBar;
  /**  */
  QString whoisBinary;
  /**  */
  KAboutData * aboutData;
  /**  */
  int whoisType;
  /**  */
  QString eMailAddress;
  /**  */
  double whoisConfigVersion;


  /** No descriptions */
  char * getHomeDirectory(int UID);
  /** No descriptions */
  char * getUserName(int UID);
  /** No descriptions */
  void clearConfig();
  /** No descriptions */
  void initMenuBar();
  /** No descriptions */
  void ShowInverseDlg();
  /** No descriptions */
  void ShowInternicRegistrarDlg();
  /** No descriptions */
  void writeConfig();
  /** No descriptions */
  void ShowInternicNameserverSearchDlg();
  /** No descriptions */
//Del von KDevelop:
protected slots: // Protected slots
  /** No descriptions */
  virtual void slotSearchReturn();
private slots: // Private slots
  /** No descriptions */
  void receiveOutput(KProcess *proc,char *buffer,int len);
  /** No descriptions */
  void slotINTERNICClicked(int id);
  /** No descriptions */
//Del von KDevelop:
  /** No descriptions */

protected slots: // Protected slots
  /** No descriptions */
  virtual void slotServerActivated(int item);
  /** No descriptions */
  virtual void closeEvent ( QCloseEvent * e );
protected slots: // Protected slots
  /** No descriptions */
  virtual void slotConfig();
protected slots: // Protected slots
  /** No descriptions */
  virtual void slotBtnClose();
  /** No descriptions */
  virtual void resizeEvent(QResizeEvent *sizeEvent);

protected slots: // Protected slots
 /** No descriptions */
  void slotMenuClicked(int id);
  /** No descriptions */
  void slotFileClicked(int id);
  /** No descriptions */
  void slotRIPEClicked(int menu_id);
  /** No descriptions */

public: // Public attributes
  /** No descriptions */
  const QString & getWhoisBinary();
  /** No descriptions */
  const int  getWhoisType();
  /** No descriptions */
  void setWhoisType(const int whoisT);
  /** No descriptions */
  void setWhoiseMailAddress(const QString &email);
  /** No descriptions */
  const QString & getWhoiseMail();
  /** No descriptions */
  void generateInverseWhoisCommand(const QString &templateStr);
  /** No descriptions */
  void setWhoisConfigVersion(double version);
  /** No descriptions */

};

#endif
