/***************************************************************************
                          kwhoisconfig.cpp  -  description
                             -------------------
    begin                : Mon Aug 27 2001
    copyright            : (C) 2001 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kwhoisconfig.h"

KWhoisConfig::KWhoisConfig(QWidget *parent, const char *name, QAsciiDict<QString> dict) : KWhoisConfigUI(parent,name,true) {
	QStringList groupList;

	dictServer=dict;
	
	QAsciiDictIterator<QString> it(dict);
	while ( it.current() ) {
		QListViewItem *ne=new QListViewItem(lviewWhoisServer,QString(it.currentKey()),(*it.current()));
		lviewWhoisServer->insertItem(ne);
		++it;
	}
	
}
KWhoisConfig::~KWhoisConfig(){
}
/** No descriptions */
void KWhoisConfig::accept(){
	QDialog::accept();
}

/** No descriptions */
void KWhoisConfig::slotAdd(){
	KWhoisConfigAdd *add;
	
	add=new KWhoisConfigAdd(this,"KWhois Config Add","","");
	if (add->exec()) {
		QListViewItem *ne=new QListViewItem(lviewWhoisServer,QString(add->getDescription()),add->getWhoisServer());
		lviewWhoisServer->insertItem(ne);
		dictServer.insert(QString(add->getDescription()),new QString(add->getWhoisServer()));
	}		
	delete add;
}
/** No descriptions */
const QAsciiDict<QString> & KWhoisConfig::getServerDict(){
	return dictServer;
}
/** No descriptions */
void KWhoisConfig::slotDelete(){
	QListViewItem *me;
	me=lviewWhoisServer->selectedItem();
	dictServer.remove(me->text(0));
	lviewWhoisServer->removeItem(lviewWhoisServer->selectedItem());
	
}
/** No descriptions */
void KWhoisConfig::slotModify(){
	QListViewItem *me;
	KWhoisConfigAdd *me1;
	QString bla;
	
	me=lviewWhoisServer->selectedItem();
	me1=new KWhoisConfigAdd(this,"",me->text(0),me->text(1));
	if (me1->exec()) {
		if (dictServer.find(QString(me1->getDescription()))) {
			dictServer.replace(QString(me1->getDescription()),new QString(QString(me1->getWhoisServer())));
			lviewWhoisServer->removeItem(lviewWhoisServer->selectedItem());
			lviewWhoisServer->insertItem(new QListViewItem(lviewWhoisServer,QString(me1->getDescription()),QString(me1->getWhoisServer())));
		} else {
			dictServer.remove(QString(me->text(0)));
			dictServer.insert(QString(me1->getDescription()),new QString(QString(me1->getWhoisServer())));
			lviewWhoisServer->removeItem(lviewWhoisServer->selectedItem());
			lviewWhoisServer->insertItem(new QListViewItem(lviewWhoisServer,QString(me1->getDescription()),QString(me1->getWhoisServer())));
		}
	}
}
/** No descriptions */
void KWhoisConfig::slotLviewDoubleClick(QListViewItem *item){
	slotModify();
}
