/***************************************************************************
                          kwhoisinternicnameserversearch.cpp  -  description
                             -------------------
    begin                : Sun Nov 18 2001
    copyright            : (C) 2001 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kwhoisinternicnameserversearch.h"

KWhoisInternicNameserverSearch::KWhoisInternicNameserverSearch(QWidget *parent, const char *name ,const char *wB,int wT) : KWhoisInternicNameserverSearchUI(parent,name,true) {
	searchProc=new KProcess();
	connect(searchProc,SIGNAL(receivedStdout(KProcess *,char *,int)),this,SLOT(receiveOutput(KProcess *,char *,int)));
	connect(searchProc,SIGNAL(receivedStderr(KProcess *,char *,int)),this,SLOT(receiveOutput(KProcess *,char *,int)));
	connect(searchProc,SIGNAL(processExited(KProcess *)),this,SLOT(slotProcExit(KProcess *)));
	whoisBinary=wB;
	whoisType=wT;
	entryServername->setReadOnly(true);
	entryIPAddress->setReadOnly(true);
	entryRegistrar->setReadOnly(true);
	entryWhoisServer->setReadOnly(true);
	entryReferralURL->setReadOnly(true);
	
}
KWhoisInternicNameserverSearch::~KWhoisInternicNameserverSearch(){
	delete searchProc;
}
/** No descriptions */
void KWhoisInternicNameserverSearch::slotBtnSearch(){
output="";
	searchProc->clearArguments();
	if (whoisType==0||whoisType==2) {
		*searchProc << whoisBinary;
		*searchProc << "-h";
		*searchProc << "whois.internic.net";
		*searchProc << "--";
		*searchProc << "nameserver";
		*searchProc << entryNameServer->text();
	}
	if (whoisType==1) {
				*searchProc << whoisBinary;
				*searchProc << "nameserver "+entryNameServer->text()+"@whois.internic.net";
	}
	searchProc->start(KProcess::NotifyOnExit,KProcess::AllOutput);	
}
/** No descriptions */
void KWhoisInternicNameserverSearch::slotProcExit(KProcess *proc){
	parseOutput();
}
/** No descriptions */
void KWhoisInternicNameserverSearch::receiveOutput(KProcess *proc,char *buffer,int len){
	char *buf1;
	buf1=(char *)malloc(len+1);
	buf1=(char *)memmove(buf1,buffer,len);
	buf1[len]=0;
	output.append(buf1);
	free(buf1);
}
/** No descriptions */
void KWhoisInternicNameserverSearch::parseOutput(){
	KRegExp *reg;
	QStringList list;
	QString bla;
	reg=new KRegExp("[\\s]*(Server Name|IP Address|Registrar|Whois Server|Referral URL):[\\s]*(.+?)","");
	list=QStringList::split(QRegExp("\\n",true),output,false);
	for (QStringList::Iterator it4=list.begin();it4 !=list.end();++it4) {
		bla=QString(*it4);
		reg->match(bla);
		if (QString(reg->group(1)).contains("Server Name")) {
			entryServername->setText(QString(reg->group(2)).stripWhiteSpace());
		}
		if (QString(reg->group(1)).contains("IP Address")) {
			entryIPAddress->setText(QString(reg->group(2)).stripWhiteSpace());
		}
		if (QString(reg->group(1)).contains("Registrar")) {
			entryRegistrar->setText(QString(reg->group(2)).stripWhiteSpace());
		}
		if (QString(reg->group(1)).contains("Whois Server")) {
			entryWhoisServer->setText(QString(reg->group(2)).stripWhiteSpace());
		}
		if (QString(reg->group(1)).contains("Referral URL")) {
			entryReferralURL->setText(QString(reg->group(2)).stripWhiteSpace());
		}
	}
	delete reg;
}
