/***************************************************************************
                          kwhoisinterreg.cpp  -  description
                             -------------------
    begin                : Thu Nov 15 2001
    copyright            : (C) 2001 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kwhoisinterreg.h"

KWhoisInterReg::KWhoisInterReg(QWidget *parent, const char *name,const char *wB,int wT,QAsciiDict<QString> wD) : KWhoisInterRegistrarUI(parent,name,true) {
	searchProc=new KProcess();
	connect(searchProc,SIGNAL(receivedStdout(KProcess *,char *,int)),this,SLOT(receiveOutput(KProcess *,char *,int)));
	connect(searchProc,SIGNAL(receivedStderr(KProcess *,char *,int)),this,SLOT(receiveOutput(KProcess *,char *,int)));
	connect(searchProc,SIGNAL(processExited(KProcess *)),this,SLOT(slotProcExit(KProcess *)));
	whoisBinary=wB;
	whoisType=wT;
	whoisDict=wD;
}

KWhoisInterReg::~KWhoisInterReg(){
	delete searchProc;
}
/** No descriptions */
void KWhoisInterReg::slotBtnSearch(){
	lviewWhoisServer->clear();
	output="";
	searchProc->clearArguments();
	if (whoisType==0||whoisType==2) {
		*searchProc << whoisBinary;
		*searchProc << "-h";
		*searchProc << "whois.internic.net";
		*searchProc << "--";
		*searchProc << "registrar";
		*searchProc << "sum";
		*searchProc << entryRegistrar->text();
	}
	if (whoisType==1) {
				*searchProc << whoisBinary;
				*searchProc << "registrar sum "+entryRegistrar->text()+"@whois.internic.net";
	}
	searchProc->start(KProcess::NotifyOnExit,KProcess::AllOutput);	
}
/** No descriptions */
void KWhoisInterReg::receiveOutput(KProcess *proc,char *buffer,int len){
	char *buf1;
	buf1=(char *)malloc(len+1);
	buf1=(char *)memmove(buf1,buffer,len);
	buf1[len]=0;
	output.append(buf1);
	free(buf1);
}
/** No descriptions */
void KWhoisInterReg::slotProcExit(KProcess *proc){
	parseOutput();
}
/** No descriptions */
void KWhoisInterReg::parseOutput(){	
	KRegExp *reg;		
	QStringList list;
	QString bla;
	reg=new KRegExp("^([A-Z0-9\\,\\.\\ \\/\\-]+)[\\s]*(.+?)");
	list=QStringList::split(QRegExp("\\n",true),output,true);
	for (QStringList::Iterator it4=list.begin();it4 !=list.end();++it4) {
		bla=QString(*it4);
		if (!bla.isEmpty() && !bla.contains("\\n")) {
			reg->match(bla);
			if (QString(reg->group(2)).contains(QRegExp("[a-z]+\\.[a-z\\-]+\\.[a-z]+",true))) {
				QListViewItem *item=new QListViewItem(lviewWhoisServer,QString(reg->group(1)).stripWhiteSpace(),QString(reg->group(2)).stripWhiteSpace());
				lviewWhoisServer->insertItem(item);
			}
		}
	}
	delete reg;
}

/** No descriptions */
QAsciiDict<QString> KWhoisInterReg::getDict(){
	return whoisDict;
}
/** No descriptions */
void KWhoisInterReg::slotLViewRightBtn(QListViewItem *lviewitem,const QPoint &pt,int no){
	
	popUp=new QPopupMenu(this);
	popUp->insertItem(i18n("Add"),100,1);
	popUp->insertItem(i18n("Add selected"),101,2);
	switch (popUp->exec(pt)) {
		case 100: // add
			whoisDict.insert(QString(lviewitem->text(0)),new QString(lviewitem->text(1)));
		break;
		case 101: // add selected
		            QListViewItemIterator  it(lviewWhoisServer);
		            for (; it.current();++it) {
		            	if (it.current()->isSelected()) {
		            		whoisDict.insert(QString(it.current()->text(0)),new QString(it.current()->text(1)));
						}
					}
		break;
	}
	delete popUp;
}
