/***************************************************************************
                          kwhoisripeinverse.cpp  -  description
                             -------------------
    begin                : Tue Nov 13 2001
    copyright            : (C) 2001 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kwhoisripeinverse.h"

KWhoisRIPEInverse::KWhoisRIPEInverse(QWidget *parent, const char *name ) : KWhoisRIPEInverseUI(parent,name,true) {
}
KWhoisRIPEInverse::~KWhoisRIPEInverse(){
}
/** No descriptions */
const QString KWhoisRIPEInverse::getAttributes(){
	QString t;
	t="";
	if (checkAttrAdminC->isChecked()) {
		t+="ac";
	}
	if (checkAttrAuthorC->isChecked()) {
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="ah";
	}
	if (checkAttrCrossMnt->isChecked()) {
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="ct";
	}
	if (checkAttrCrossNfy->isChecked()) {
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="cn";
	}
	
	if (checkAttrLocalAS->isChecked()) {
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="la";
	}
	if (checkAttrMbrsByRef->isChecked()) {
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="mr";
	}
	if (checkAttrMemberOf->isChecked()) {
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="mo";
	}
	if (checkAttrMntBy->isChecked()) {
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="mb";
	}
	if (checkAttrMntLower->isChecked()) {
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="ml";
	}
	if (checkAttrMntNfy->isChecked()) {
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="mn";
	}
	if (checkAttrMntRoutes->isChecked()) {
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="mu";
	}
	
	if (checkAttrNotify->isChecked()) {
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="ny";
	}
	if (checkAttrNserver->isChecked()) {
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="ns";
	}
	if (checkAttrOrigin->isChecked()) {
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="or";
	}
	if (checkAttrReferralBy->isChecked()) {
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="rb";
	}
	if (checkAttrRevSrv->isChecked()){
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="rz";
	}
	if (checkAttrSubDom->isChecked()) {
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="sd";
	}
	
	if (checkAttrTechC->isChecked()) {
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="tc";
	}
	if (checkAttrUpdTo->isChecked()) {
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="dt";
	}
	if (checkAttrZoneC->isChecked()) {
		if (!t.isEmpty()) {
			t+=",";
		}
		t+="zc";
	}
	return t;
}
/** No descriptions */
void KWhoisRIPEInverse::slotCheckGroup(bool check){
	if (checkAttrAdminC->isChecked() ||
		checkAttrAuthorC->isChecked() ||
		checkAttrCrossNfy->isChecked()||
		checkAttrTechC->isChecked() 	||
		checkAttrZoneC->isChecked() ) {
			checkAttrCrossMnt->setEnabled(false);
			checkAttrLocalAS->setEnabled(false);
			checkAttrMbrsByRef->setEnabled(false);
			checkAttrMemberOf->setEnabled(false);
			checkAttrMntBy->setEnabled(false);
			checkAttrMntLower->setEnabled(false);
			checkAttrMntNfy->setEnabled(false);
			checkAttrMntRoutes->setEnabled(false);
			checkAttrNotify->setEnabled(false);
			checkAttrNserver->setEnabled(false);
			checkAttrOrigin->setEnabled(false);
			checkAttrReferralBy->setEnabled(false);
			checkAttrRevSrv->setEnabled(false);
			checkAttrSubDom->setEnabled(false);
			checkAttrUpdTo->setEnabled(false);
		} else if (	checkAttrCrossMnt->isChecked()	||
				checkAttrMbrsByRef->isChecked()	||
				checkAttrMntBy->isChecked()		||
				checkAttrMntLower->isChecked()	||
				checkAttrMntRoutes->isChecked()	||
				checkAttrReferralBy->isChecked() ) {
				
				checkAttrAdminC->setEnabled(false);
				checkAttrAuthorC->setEnabled(false);
				checkAttrCrossNfy->setEnabled(false);
				checkAttrLocalAS->setEnabled(false);
				checkAttrMemberOf->setEnabled(false);
				checkAttrMntNfy->setEnabled(false);
				checkAttrNotify->setEnabled(false);
				checkAttrNserver->setEnabled(false);
				checkAttrOrigin->setEnabled(false);
				checkAttrRevSrv->setEnabled(false);
				checkAttrSubDom->setEnabled(false);
				checkAttrTechC->setEnabled(false);
				checkAttrUpdTo->setEnabled(false);
				checkAttrZoneC->setEnabled(false);
			} else if (checkAttrMemberOf->isChecked()) {
			   checkAttrAdminC->setEnabled(false);
			   checkAttrAuthorC->setEnabled(false);
			   checkAttrCrossMnt->setEnabled(false);
			   checkAttrCrossNfy->setEnabled(false);
			   checkAttrLocalAS->setEnabled(false);
			   checkAttrMbrsByRef->setEnabled(false);
			   checkAttrMntBy->setEnabled(false);
			   checkAttrMntLower->setEnabled(false);
			   checkAttrMntNfy->setEnabled(false);
			   checkAttrMntRoutes->setEnabled(false);
			   checkAttrNotify->setEnabled(false);
			   checkAttrNserver->setEnabled(false);
			   checkAttrOrigin->setEnabled(false);
			   checkAttrReferralBy->setEnabled(false);
			   checkAttrRevSrv->setEnabled(false);
			   checkAttrSubDom->setEnabled(false);
			   checkAttrTechC->setEnabled(false);
			   checkAttrUpdTo->setEnabled(false);
			   checkAttrZoneC->setEnabled(false);			
			} else if (	checkAttrMntNfy->isChecked()	||
							checkAttrNotify->isChecked()	||
							checkAttrUpdTo->isChecked() ) {
			   checkAttrAdminC->setEnabled(false);
			   checkAttrAuthorC->setEnabled(false);
			   checkAttrCrossMnt->setEnabled(false);
			   checkAttrCrossNfy->setEnabled(false);
			   checkAttrLocalAS->setEnabled(false);
			   checkAttrMbrsByRef->setEnabled(false);
			   checkAttrMemberOf->setEnabled(false);
			   checkAttrMntBy->setEnabled(false);
			   checkAttrMntLower->setEnabled(false);
			   checkAttrMntRoutes->setEnabled(false);
			   checkAttrNserver->setEnabled(false);
			   checkAttrOrigin->setEnabled(false);
			   checkAttrReferralBy->setEnabled(false);
			   checkAttrRevSrv->setEnabled(false);
			   checkAttrSubDom->setEnabled(false);
			   checkAttrTechC->setEnabled(false);
			   checkAttrZoneC->setEnabled(false);
			} else if (checkAttrLocalAS->isChecked()) {
			   checkAttrAdminC->setEnabled(false);
			   checkAttrAuthorC->setEnabled(false);
			   checkAttrCrossMnt->setEnabled(false);
			   checkAttrCrossNfy->setEnabled(false);
			   checkAttrMbrsByRef->setEnabled(false);
			   checkAttrMemberOf->setEnabled(false);
			   checkAttrMntBy->setEnabled(false);
			   checkAttrMntLower->setEnabled(false);
			   checkAttrMntNfy->setEnabled(false);
			   checkAttrMntRoutes->setEnabled(false);
			   checkAttrNotify->setEnabled(false);
			   checkAttrNserver->setEnabled(false);
			   checkAttrOrigin->setEnabled(false);
			   checkAttrReferralBy->setEnabled(false);
			   checkAttrRevSrv->setEnabled(false);
			   checkAttrSubDom->setEnabled(false);
			   checkAttrTechC->setEnabled(false);
			   checkAttrUpdTo->setEnabled(false);
			   checkAttrZoneC->setEnabled(false);
			} else if (	checkAttrNserver->isChecked()	||
							checkAttrRevSrv->isChecked()) {
			   checkAttrAdminC->setEnabled(false);
			   checkAttrAuthorC->setEnabled(false);
			   checkAttrCrossMnt->setEnabled(false);
			   checkAttrCrossNfy->setEnabled(false);
			   checkAttrLocalAS->setEnabled(false);
			   checkAttrMbrsByRef->setEnabled(false);
			   checkAttrMemberOf->setEnabled(false);
			   checkAttrMntBy->setEnabled(false);
			   checkAttrMntLower->setEnabled(false);
			   checkAttrMntNfy->setEnabled(false);
			   checkAttrMntRoutes->setEnabled(false);
			   checkAttrNotify->setEnabled(false);
			   checkAttrOrigin->setEnabled(false);
			   checkAttrReferralBy->setEnabled(false);
			   checkAttrSubDom->setEnabled(false);
			   checkAttrTechC->setEnabled(false);
			   checkAttrUpdTo->setEnabled(false);
			   checkAttrZoneC->setEnabled(false);
			} else if (checkAttrOrigin->isChecked()) {
			   checkAttrAdminC->setEnabled(false);
			   checkAttrAuthorC->setEnabled(false);
			   checkAttrCrossMnt->setEnabled(false);
			   checkAttrCrossNfy->setEnabled(false);
			   checkAttrLocalAS->setEnabled(false);
			   checkAttrMbrsByRef->setEnabled(false);
			   checkAttrMemberOf->setEnabled(false);
			   checkAttrMntBy->setEnabled(false);
			   checkAttrMntLower->setEnabled(false);
			   checkAttrMntNfy->setEnabled(false);
			   checkAttrMntRoutes->setEnabled(false);
			   checkAttrNotify->setEnabled(false);
			   checkAttrNserver->setEnabled(false);
			   checkAttrReferralBy->setEnabled(false);
			   checkAttrRevSrv->setEnabled(false);
			   checkAttrSubDom->setEnabled(false);
			   checkAttrTechC->setEnabled(false);
			   checkAttrUpdTo->setEnabled(false);
			   checkAttrZoneC->setEnabled(false);
			} else if (checkAttrSubDom->isChecked()) {
			   checkAttrAdminC->setEnabled(false);
			   checkAttrAuthorC->setEnabled(false);
			   checkAttrCrossMnt->setEnabled(false);
			   checkAttrCrossNfy->setEnabled(false);
			   checkAttrLocalAS->setEnabled(false);
			   checkAttrMbrsByRef->setEnabled(false);
			   checkAttrMemberOf->setEnabled(false);
			   checkAttrMntBy->setEnabled(false);
			   checkAttrMntLower->setEnabled(false);
			   checkAttrMntNfy->setEnabled(false);
			   checkAttrMntRoutes->setEnabled(false);
			   checkAttrNotify->setEnabled(false);
			   checkAttrNserver->setEnabled(false);
			   checkAttrOrigin->setEnabled(false);
			   checkAttrReferralBy->setEnabled(false);
			   checkAttrRevSrv->setEnabled(false);
			   checkAttrTechC->setEnabled(false);
			   checkAttrUpdTo->setEnabled(false);
			   checkAttrZoneC->setEnabled(false);
			
			} else {
			   checkAttrAdminC->setEnabled(true);
			   checkAttrAuthorC->setEnabled(true);
			   checkAttrCrossMnt->setEnabled(true);
			   checkAttrCrossNfy->setEnabled(true);
			   checkAttrLocalAS->setEnabled(true);
			   checkAttrMbrsByRef->setEnabled(true);
			   checkAttrMemberOf->setEnabled(true);
			   checkAttrMntBy->setEnabled(true);
			   checkAttrMntLower->setEnabled(true);
			   checkAttrMntNfy->setEnabled(true);
			   checkAttrMntRoutes->setEnabled(true);
			   checkAttrNotify->setEnabled(true);
			   checkAttrNserver->setEnabled(true);
			   checkAttrOrigin->setEnabled(true);
			   checkAttrReferralBy->setEnabled(true);
			   checkAttrRevSrv->setEnabled(true);
			   checkAttrSubDom->setEnabled(true);
			   checkAttrTechC->setEnabled(true);
			   checkAttrUpdTo->setEnabled(true);
			   checkAttrZoneC->setEnabled(true);
			}
}
/** No descriptions */
const QString KWhoisRIPEInverse::getQueryString(){
	QString t;
	t=entryWhatToSearch->text();
	return t;
}
